	include "include\tios92.h"	;les librairies utilises par le programme
	include "include\flib92.h"
	include "include\hufflib92.h"
	include "include\graphl92.h"

	xdef _main			;il commence  l'adresse main
	xdef _comment			;il possde un espace commentaire

up	equ	338			;liste des "variables", en fait les constantes du programme.
down	equ	344
left	equ	337
right	equ	340
KF5	equ	272
ESC	equ	264

SetFont MACRO				;Macro choisissant la police  utiliser
        move.w \1,-(a7)			;place le premier argument sur la pile. L'argument a la longueur d'un mot
        jsr tios::FontSetSys
        addq.l #2,a7			;dplace l'adresse du pointeur de pile de deux. L'adresse du pointeur de pile est cod sur un mot double.
        ENDM

WriteStr	MACRO			;Macro crivant un texte  un endroit prcis,
        move.w \1,-(a7)			;dans une couleur dtermin, un texte point par une adresse
        pea \2(pc)
        move.w \3,-(a7)
        move.w \4,-(a7)
        jsr tios::DrawStrXY
        lea 10(a7),a7
        ENDM

_main					;dpart du programme
	move.l #1,d7			;d7 = emplacement vertical de la croix
	move.l #1,d6			;d6 = emplacement horizontal de la croix
	move.l #1,d5			;d5 = numro de l'lment
	move.l #5,d0
	move.l #4,d1
	move.l #9,d2
	move.l #8,d3
	movem.l d0-d3,-(a7)

Ecran1	jsr flib::zap_screen		;efface l'cran
	include "ecran.asm"		;affiche l'cran
	SetFont #1			;choisit la police 1 comme police d'affichage
        move.w #4,-(a7)
        pea masse(pc)
        move.w #118,-(a7)
        move.w #54,-(a7)		;placement des infos sur la pile
        jsr tios::DrawStrXY		;affiche la phrase point par le label masse  l'emplacement (2;92) en couleur normale
        lea 10(a7),a7			;enlve les infos de la pile
	bra Affich1			;va afficher les infos de l'lment en cours

KEY	jsr flib::idle_loop		;attente de l'appui sur une touche
	cmp.w #right,d0			;compare la valeur retourne par la sous-routine et la valeur de la touche DROITE
	beq Droit			;si la valeur est la mme, alors aller au label droit
	cmp.w #left,d0
	beq Gauche
	cmp.w #down,d0
	beq Bas
	cmp.w #up,d0
	beq Haut

	cmp.w #KF5,d0
	beq F5
	cmp.w #ESC,d0			;si la touche appuye est ESC, alors aller  exit
	beq exit
	bra KEY

F5	jsr flib::zap_screen		;Caractristiques du programme affichs lors de l'appui sur F5
	SetFont #2
	WriteStr #4,nom,#20,#45
	SetFont #1
	WriteStr #4,version,#40,#82
	SetFont #0
	WriteStr #4,auteur,#55,#63
	WriteStr #4,Site,#70,#55
	SetFont #1
	jsr flib::idle_loop
	bra Ecran1

Droit	cmp.w #112,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche DROITE
	beq KEY
	addq.w #1,d5
	addq.w #1,d6
	cmp.w #19,d6
	bne.s SD1
	moveq.w #1,d6
	addq.w #1,d7
SD1	cmp.w #2,d6
	bne.s SD2
	cmp.w #1,d7
	bne.s SD2
	moveq.w #18,d6
SD2	cmp.w #3,d6
	bne.s SD4
	cmp.w #3,d7
	bgt.s SD3
	moveq.w #13,d6
	bra.s SD4
SD3	cmp.w #6,d7
	blt.s SD4
	cmp.w #7,d7
	bgt.s SD4
	addq.w #2,d7
SD4	cmp.w #18,d6
	bne.s SD5
	cmp.w #8,d7
	blt.s SD5
	moveq.w #4,d6
	subq.w #2,d7
SD5	bsr Efface
	bra Affich1

Gauche	cmp.w #1,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche GAUCHE
	beq KEY
	subq.w #1,d5
	subq.w #1,d6
	cmp.w #0,d6
	bne.s SG1
	moveq.w #18,d6
	subq.w #1,d7
SG1	cmp.w #17,d6
	bne.s SG2
	cmp.w #1,d7
	bne.s SG2
	moveq.w #1,d6
SG2	cmp.w #12,d6
	bne.s SG3
	cmp.w #3,d7
	bgt.s SG3
	move.w #2,d6
SG3	cmp.w #3,d6
	bne.s SG4
	cmp.w #6,d7
	blt.s SG4
	cmp.w #7,d7
	bgt.s SG4
	addq.w #2,d7
	moveq.w #17,d6
SG4	cmp.w #2,d6
	bne.s SG5
	cmp.w #8,d7
	blt.s SG5
	moveq.w #2,d6
	subq.w #2,d7
SG5	bsr Efface
	bra Affich1

Bas	cmp.w #1,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche BAS
	beq SB1
	cmp.w #13,d5
	blt SB2
	cmp.w #39,d5
	blt SB3
	beq KEY
	cmp.w #72,d5
	blt.s SB5
	cmp.w #81,d5
	blt.s SB5
	cmp.w #86,d5
	blt.s SB6
	cmp.w #104,d5
	blt KEY
SB7	sub.w #46,d5
	bra.s SBF
SB6	addq.w #1,d7
	sub.w #14,d5
	bra.s SBF
SB5	add.w #32,d5
	bra.s SBF
SB3	add.w #18,d5
	bra.s SBF
SB2	addq.w #8,d5
	bra.s SBF
SB1	addq.w #2,d5
SBF	addq.w #1,d7
	bsr Efface
	bra Affich1

Haut	cmp.w #3,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche HAUT
	blt KEY
	beq SH5
	cmp.w #10,d5
	blt KEY
	cmp.w #21,d5
	blt SH1
	cmp.w #31,d5
	blt KEY
	cmp.w #57,d5
	blt SH2
	beq KEY
	cmp.w #67,d5
	blt SH3
	cmp.w #72,d5
	blt.s SH4
SH7	sub.w #32,d5
	bra.s SHF
SH5	subq.w #2,d5
	bra.s SHF
SH4	subq.w #1,d7
	add.w #14,d5
	bra.s SHF
SH3	add.w #46,d5
	bra.s SHF
SH2	sub.w #18,d5
	bra.s SHF
SH1	subq.w #8,d5
SHF	subq.w #1,d7
	bsr Efface

Affich1					;Affiche la croix ainsi que le nom et la masse molaire de l'lment
	move.l d5,d2			;place le contenu de d5 dans d2 (numro de l'lment)
	mulu.w #30,d2			;comme chaque lment prend #30 octet de place, multiplier 30 par le numro de l'lment
	sub.w #30,d2			;soustraire #30  d2, car le premier lment n'est pas  compter
	lea Table(PC),a6		;mettre l'adresse effective de la base de donnes dans a6
	adda.l d2,a6			;ajouter  l'adresse de la base de donnes le dplacement pour trouver l'lment
	movea.l a6,a3			;mettre le contenu de a5 dans a3

	move.w #4,-(a7)			;choisir la couleur normale
	pea (a3)			;mettre le contenu de a3 sur la pile
	move.w #5,-(a7)			;coordonnes
	move.w #54,-(a7)
        jsr tios::DrawStrXY		;crire le nom de l'lment sur l'cran
	lea 8(a7),a7			;retirer les infos sauf celles de la couleur
	lea 21(a3),a3			;ajouter 21 au contenu de a3
	pea (a3)			;ritrer l'opration d'criture  l'cran
	move.w #118,-(a7)
	move.w #102,-(a7)
        jsr tios::DrawStrXY
	lea 10(a7),a7

					;dessin de la croix
	movem.l (a7)+,d0-d3		;enlve les coordonnes de la pile
	move.l d7,d1			;mettre d7 dans d1 (placement vertical de l'lment)
	mulu.w #12,d1			;multiplier cet emplacement par 12 (chaque ligne du tableau correspond  12 lignes de l'cran)
	subq.w #8,d1			;dcalage d'offset
	move.l d6,d0			;mettre d6 dans d0 (placement horizontal de l'lment)
	mulu.w #13,d0			;multiplier cet emplacement par 13 (chaque colonne du tableau correspond  13 colonnes de l'cran)
	subq.w #8,d0			;dcalage d'offset

	cmp.w #8,d7			; quelle ligne est-on ?
	blt.s SA2			;si on est une autre ligne que 8 ou 9, aller  SA2
SA1	addq.w #4,d1			;ajouter  d1 2 lignes
SA2	move.w #9,d2
	move.w #8,d3
	move.w #2,d4
	jsr graphlib::fill
	movem.l d0-d3,-(a7)		;place les coordonnes sur la pile
	bra KEY

exit	movem.l (a7)+,d0-d3
	rts				;fin du programme TI

;***Sous-routine***
Efface	move.l (a7)+,a6			;enre
	movem.l (a7)+,d0-d3		;Efface la croix  l'emplacement mmoire indiqu sur la pile
	move.w #1,d4
	jsr graphlib::fill
	movem.l d0-d3,-(a7)
	move.l a6,-(a7)
	rts

;***Donnes***
	include "Databasl.asm"

masse	dc.b "masse :          g/mol",0
nom	dc.b "Tableau priodique",0
auteur	dc.b "Matthieu Brucher a.k.a. Miles",0
version	dc.b "version 3.1",0
Site	dc.b "http://www.citeweb.net/MMiles",0

_comment				;commentaire affich  l'extrieur du programme
	dc.b "Tableau priodique light",0

	end				;fin du programme asm
